"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.assertCommand = void 0;
const tslib_1 = require("tslib");
const index_1 = require("../../core/loggin/index");
const budgets_1 = require("./utils/budgets");
const generate_reports_1 = require("../collect/processes/generate-reports");
const file_1 = require("../../core/file");
const params_1 = require("../collect/utils/params");
exports.assertCommand = {
    command: 'assert',
    description: 'Setup .user-flowrc.json',
    module: {
        handler: (argv) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
            (0, index_1.logVerbose)(`run "assert" as a yargs command`);
            const cfg = (0, params_1.getCollectCommandOptionsFromArgv)(argv);
            const json = JSON.parse((0, file_1.readFile)('./packages/cli/docs/raw/order-coffee.uf.json').toString());
            const mdReport = (0, generate_reports_1.generateMdReport)(json);
            console.log('md report', mdReport);
            //  await run(cfg);
        })
    }
};
function run(argv) {
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        (0, index_1.logVerbose)((0, budgets_1.readBudgets)());
        return Promise.resolve();
    });
}
exports.run = run;
//# sourceMappingURL=index.js.map