"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setupFormat = void 0;
const tslib_1 = require("tslib");
const enquirer_1 = require("enquirer");
const interactive_1 = require("../../../global/options/interactive");
const format_constant_1 = require("../../collect/options/format.constant");
const validation_1 = require("../../../core/validation");
const constants_1 = require("../../collect/constants");
const pre_set_1 = require("../../../pre-set");
function setupFormat(config) {
    var _a;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        let format = [];
        if ((0, interactive_1.get)()) {
            let initialFormat = 
            // take the provided formats from cli params or the rc file if given and convert it to a string (yes we cant use multiple initial values :( )
            Array.isArray((_a = config === null || config === void 0 ? void 0 : config.persist) === null || _a === void 0 ? void 0 : _a.format) ? config.persist.format[0] :
                typeof config.persist.format === 'string' ? config.persist.format :
                    // if not use default format from the preset as a suggestion in the prompt choice
                    undefined;
            const { f } = initialFormat !== undefined ? { f: [initialFormat] } : yield (0, enquirer_1.prompt)([
                {
                    type: 'multiselect',
                    name: 'f',
                    message: format_constant_1.PROMPT_PERSIST_FORMAT,
                    choices: constants_1.REPORT_FORMAT_OPTIONS,
                    initial: initialFormat ? constants_1.REPORT_FORMAT_VALUES.indexOf(initialFormat) : constants_1.REPORT_FORMAT_VALUES.indexOf((0, pre_set_1.getEnvPreset)().format[0]),
                    // @NOTICE typing is broken here
                    result(value) {
                        const values = value;
                        return values.map((name) => constants_1.REPORT_FORMAT_VALUES[constants_1.REPORT_FORMAT_NAMES.indexOf(name)]);
                    },
                    muliple: true
                }
            ]);
            format = f || [];
            if ((format === null || format === void 0 ? void 0 : format.length) === 0) {
                return setupFormat(config);
            }
        }
        // Validate
        const allOf = validation_1.VALIDATORS.allOf(constants_1.REPORT_FORMAT_VALUES);
        const errors = (0, validation_1.applyValidations)(format, [
            validation_1.VALIDATORS.required,
            allOf
        ]);
        if ((0, validation_1.hasError)(errors)) {
            if (errors.required) {
                throw new Error(format_constant_1.ERROR_PERSIST_FORMAT_REQUIRED);
            }
            if (errors.allOf) {
                console.log('errors.allOf: ', errors);
                throw new Error((0, format_constant_1.ERROR_PERSIST_FORMAT_WRONG)(errors.allOf.value));
            }
        }
        return Object.assign(Object.assign({}, config), { persist: Object.assign(Object.assign({}, config === null || config === void 0 ? void 0 : config.persist), { format }) });
    });
}
exports.setupFormat = setupFormat;
//# sourceMappingURL=format.setup.js.map